SET TERM ^ ;

CREATE  PROCEDURE CREATE_TABEL_FROM_DATE_BDW (
    DATETABEL DATE,
    BDW DATE)
AS
DECLARE VARIABLE ID_TABEL INTEGER;
DECLARE VARIABLE COUNT_TABEL INTEGER;
DECLARE VARIABLE ID_SOTR INTEGER;
DECLARE VARIABLE ID_GR INTEGER;
DECLARE VARIABLE BDATEWORK DATE;
DECLARE VARIABLE EDATEWORK DATE;
DECLARE VARIABLE BEGWORK_Y INTEGER;
DECLARE VARIABLE BEGWORK_M INTEGER;
DECLARE VARIABLE BEGWORK_D INTEGER;
DECLARE VARIABLE ENDWORK_Y INTEGER;
DECLARE VARIABLE ENDWORK_M INTEGER;
DECLARE VARIABLE ENDWORK_D INTEGER;
DECLARE VARIABLE DATETABEL_Y INTEGER;
DECLARE VARIABLE DATETABEL_M INTEGER;
DECLARE VARIABLE DATETABEL_D INTEGER;
DECLARE VARIABLE CUR_DAY INTEGER;
DECLARE VARIABLE SQL_STR VARCHAR(1000);
begin
  for select s.id_sotrudnik, s.id_graph, s.begworkdate, s.endworkdate from sotrudnik s
    where (((s.recindication<>'1') or (s.recindication is null))
            and (s.begworkdate=:BDW))
  into :id_sotr, :id_gr, :bdatework, :edatework
  do
  begin
    count_tabel = 0;
    for select t.id_tabel from tabel t
      where (t.DATEGRAPH =:datetabel and t.id_graph =:id_gr and t.id_sotrudnik =:id_sotr)
    into :id_tabel
    do
    begin
      count_tabel = count_tabel + 1;
    end
    if ((count_tabel = 0) and (bdatework<=:datetabel)
        and ((edatework is null)) ) then
      begin
      insert into tabel (DATEGRAPH, ID_SOTRUDNIK,
        D1, D2, D3, D4, D5, D6, D7, D8, D9, D10,
        D11, D12, D13, D14, D15, D16, D17, D18, D19, D20,
        D21, D22, D23, D24, D25, D26, D27, D28, D29, D30, D31,
        WORKDAYS, WORKHOURS, USER_ID, MODEL_ID, id_graph, calc)
      select distinct
        g.DATAGRAPH, :id_sotr,
        g.D1, g.D2, g.D3, g.D4, g.D5, g.D6, g.D7, g.D8, g.D9, g.D10,
        g.D11, g.D12, g.D13, g.D14, g.D15, g.D16, g.D17, g.D18, g.D19, g.D20,
        g.D21, g.D22, g.D23, g.D24, g.D25, g.D26, g.D27, g.D28, g.D29, g.D30, g.D31,
        g.AMOUNTWORKDAYS, g.AMOUNTWORKHOURS, 1, 1, g.id_typegraph, 1
      from graph g where ((g.id_typegraph=:id_gr) and (g.datagraph =:datetabel));
      end
    else
      begin

      end
  end
  suspend;
end


^

SET TERM ; ^